; From Hisoft Devpac Spectrum manual.
*T+
; Some code to test the Mult routine.
	ORG	#7D00

	LD	HL,50
	LD	DE,20
	CALL	Mult	;Multiply
	LD	A,H	;o/p result
	CALL	Aout
	LD	A,L
	CALL	Aout
	RET		;Return to editor

; Routine to output A in hex
	ORG	#7E00

Aout	PUSH	AF
	RRCA
	RRCA
	RRCA
	RRCA
	CALL	Nibble
	POP	AF
Nibble	AND	#F
	ADD	A,#90
	DAA
	ADC	A,#40
	DAA
	LD	IY,#5C3A	;for ROM
; It is necessary to set the printing position before calling.
; e.g. row 22, column 1 is set by PRINT AT 21,0;
	RST	#10	;ROM Call
	RET


; A fast integer multiply routine.  Multiplies HL
; by DE.  Return the result in HL.  C flag set on
; an overflow.
	ORG	#7F00

Mult	XOR	A
	SBC	HL,DE	;HL>DE?
	ADD	HL,DE
	JR	NC,Mu1	;yes
	EX	DE,HL
Mu1	OR	D
	SCF		;overflow if
	RET	NZ	;DE>255
	OR	E	;times 0?
	LD	E,D
	JR	NZ,Mu4	;no
	EX	DE,HL	;0
	RET

;Main routine.

Mu2	EX	DE,HL
	ADD	HL,DE
	EX	DE,HL
Mu3	ADD	HL,HL
	RET	C	;overflow
Mu4	RRA
	JR	NC,Mu3
	OR	A
	JR	NZ,Mu2
	ADD	HL,DE
	RET